!
! lanczos --- band-Lanczos diagonalization routines
! Christian Buth
! 05 August 2004
!
!
! Copyright (c) 2004-2006 Christian Buth
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
!
!
! Version 1.00: 15 June 2006 (Explicit interfaces for all FORTRAN
!       procedures of the complex symmetric band-Lanczos created)
!


!
! Module
!

      module lanczos
      use fortrantl
      implicit none


!
! Parameters
!

      integer, parameter :: ifile = 90          ! In the zblanc/zbnddia some files
                ! are temporarily opened and closed (RESTART, EIGENV, ZMAT);
                ! this unit number is used for this


!
! Interfaces
!

      interface
      subroutine zblanc(ndim, np, niter, neigenv, ncartsv, iparam, t, &
     &     p, z, ev, icartsv, zmatblk)
      use fortrantl
      implicit none

      integer, intent(in) :: ndim, np, niter, neigenv, &
     &          iparam(10)
      integer, intent(inout) :: ncartsv, icartsv(ncartsv)
      complex(dblprec), intent(inout) :: p(ndim,np,3), ev(ndim,neigenv), &
     &          z(niter,neigenv)
      complex(dblprec), intent(out) :: t(np+1,niter)
      external zmatblk
      end subroutine zblanc


      subroutine zbnddia(n, np, t, d, e2, z, thresh, neigenv, evlist, iparam, jnd, ps)
      use fortrantl
      implicit none

      integer, intent(in) :: n, np, iparam(2)
      integer, intent(out) :: jnd
      integer, intent(inout) :: neigenv, evlist(neigenv)
      real(dblprec), intent(in) :: thresh(3)
      real(dblprec), optional, intent(out) :: ps(n)
      complex(dblprec), intent(in) :: t(np+1,n)
      complex(dblprec), intent(out) :: d(n), e2(n), z(2*np, n)
      end subroutine zbnddia
      end interface
      end module lanczos
